/* Betriebssystem & Middleware
 *
 * Betriebssystemarchitektur WS 2004/05
 *
 * Uebung 4.3
 *
 * distributed fractal computation 
 * results are written in an memory mapped file 
 */
#include <windows.h>
#include <stdio.h>
#include "common.h"

int main(int argc, char* argv[])
{
	HANDLE procs[100];
	HANDLE file,filemapping;
    int numprocs,i,numlines;
    BYTE *datap;
	PROCESS_INFORMATION pi[100];
	STARTUPINFO si;
	short svalue;
    int   lvalue;
	unsigned char *ptr;


	if(argc<3)
	{
		fprintf(stderr,"usage: %s number_of_processes bmp_file\n",argv[0]);
		exit(1);
	}

	numprocs=atoi(argv[1]);
	if(numprocs<1 || numprocs>100)
	{
		fprintf(stderr,"Invalid number of processes [1-100].\n");
		exit(2);
	}

	file=CreateFile(argv[2],GENERIC_WRITE|GENERIC_READ,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,/*CREATE_NEW*/CREATE_ALWAYS,0,NULL);
	if(INVALID_HANDLE_VALUE==file)
	{
		ErrorExit("CreateFile",3);
	}

	filemapping=CreateFileMapping(file,NULL,PAGE_READWRITE,0,FILESIZE,"mapping");
	if(INVALID_HANDLE_VALUE==filemapping)
	{
		ErrorExit("CreateFileMapping",4);
	}
	
	datap=(BYTE*)MapViewOfFile(filemapping,FILE_MAP_ALL_ACCESS,0,0,HEADERSIZE);
    if(NULL==datap)
	{
		ErrorExit("MapViewOfFile",5);
	}
 
	numlines=YSIZE/numprocs;

    for(i=0;i<numprocs;i++)
	{
		char cmdln[100];
		int start=i*numlines;

		if(i+1==numprocs)//last proc to start
		{	 // missing lines through integer division        
			numlines=(YSIZE-numprocs*numlines)+numlines;
		}
		sprintf(cmdln,"worker.exe %s %d %d","mapping",start,numlines);

		ZeroMemory(&si,sizeof(STARTUPINFO));
		si.cb=sizeof(STARTUPINFO);
		ZeroMemory(&pi[i],sizeof(PROCESS_INFORMATION));
		//printf("%d %d %d\n",i,start,numlines);
		
		if(!CreateProcess(NULL,cmdln,NULL,NULL,FALSE,0,NULL,NULL,&si,&pi[i]))
		{
			ErrorExit("CreateProcess",6);
		}
		
	}

    ptr=&datap[0];
	svalue=0x4d42;
    memcpy(ptr,&svalue,2);//signatur
    ptr+=2;
    lvalue=XSIZE*YSIZE*3+54;
    memcpy(ptr,&lvalue,4); //filesize
    ptr+=4;
    lvalue=0;
    memcpy(ptr,&lvalue,4);//reserved
    ptr+=4;
    lvalue=54;
    memcpy(ptr,&lvalue,4);//image offset
    ptr+=4;
    lvalue=40;
    memcpy(ptr,&lvalue,4);//size of header follows
    ptr+=4;
    lvalue=XSIZE;
    memcpy(ptr,&lvalue,4);//with of image
    ptr+=4;
    lvalue=YSIZE;
    memcpy(ptr,&lvalue,4); //height of image
    ptr+=4;
    svalue=1;
    memcpy(ptr,&svalue,2); //number of planes
    ptr+=2;
    svalue=24;
    memcpy(ptr,&svalue,2); //number of pixel
    ptr+=2;
    lvalue=0; //compression
    memcpy(ptr,&lvalue,4); //compression
    ptr+=4;
    lvalue=XSIZE*YSIZE*3; 
    memcpy(ptr,&lvalue,4); //size of image
    ptr+=4;
    lvalue=0;
    memcpy(ptr,&lvalue,4); //xres  
    ptr+=4;
    lvalue=0;
    memcpy(ptr,&lvalue,4); //yres
    ptr+=4;
    lvalue=0;
    memcpy(ptr,&lvalue,4); //number of colortables
    ptr+=4;
    lvalue=0;
    memcpy(ptr,&lvalue,4); //number of important colors
    ptr+=4;

    for(i=0;i<numprocs;i++)
	{
		if(WAIT_FAILED==WaitForSingleObject(pi[i].hProcess,INFINITE))
		{
			ErrorExit("WaitForSingleObject",7);
		}
	}

	if(!UnmapViewOfFile(datap))
	{
			ErrorExit("UnmapViewOfFile",8);
	}
    if(!CloseHandle(filemapping))
	{
			ErrorExit("CloseHandle",9);
	}
	if(!CloseHandle(file))
	{
			ErrorExit("CloseHandle",10);
	}
	return 0;
}