/* Betriebssystem & Middleware
 *
 * Betriebssystemarchitektur WS 2004/05
 *
 * Uebung 4.3
 *
 * fractal generator
 * results are written in an memory mapped file 
 */
#include <windows.h>
#include <stdio.h>
#include "common.h"

int main(int argc, char* argv[])
{
	HANDLE procs[100];
	HANDLE filemapping;
    int x,y,start,numlines,pos;
    BYTE *datap;
	
	if(argc<4)
	{
		fprintf(stderr,"usage: %s mapping_name startline number_of_lines\n",argv[0]);
		exit(1);
	}

	start=atoi(argv[2]);
	if(start<0 || start>YSIZE-1)
	{
		fprintf(stderr,"Invalid start line: [0-%d]",YSIZE);
		exit(2);
	}

	numlines=atoi(argv[3]);
	if(numlines<1 || numlines>YSIZE)
	{
		fprintf(stderr,"Invalid number of lines: [1-%d]",YSIZE);
		exit(3);
	}


	filemapping=OpenFileMapping(GENERIC_READ|GENERIC_WRITE,FALSE,argv[1]);
	if(INVALID_HANDLE_VALUE==filemapping)
	{
		ErrorExit("OpenFileMapping",2);
	}

	datap=(BYTE*)MapViewOfFile(filemapping,FILE_MAP_ALL_ACCESS,0,0,FILESIZE);
    if(NULL==datap)
	{
		ErrorExit("MapViewOfFile",3);
	}

	for(y=start;y<start+numlines;y++)
	{
		for(x=0;x<XSIZE;x++)
		{
			int k = getMandelbrotPixelAt(
				x * (2.0 / XSIZE) - 1.5, 
				y * (2.0 / YSIZE) - 1.0 );

			int pos=(YSIZE-1-y)*LINESIZE+x*BYTESPERPIXEL+HEADERSIZE;
			if (k >= 200)
			{
				datap[pos]=0;
				datap[pos+1]=0;
				datap[pos+2]=0;
			}
			else
			{    // B,G,R  Pixel values in BMP
				datap[pos]=getColorValue(k, A_BLUE);
				datap[pos+1]=getColorValue(k, A_GREEN);
				datap[pos+2]=getColorValue(k, A_RED);
			}
		}
	}

	if(!UnmapViewOfFile(datap))
	{
			ErrorExit("UnmapViewOfFile",3);
	}
	if(!CloseHandle(filemapping))
	{
			ErrorExit("CloseHandle",3);
	}
	return 0;
}